"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
module.exports = {
    defaultSeverity: 'error',
    extends: ['tslint:recommended', 'tslint-react'],
    jsRules: {
        indent: [true, 'tabs'],
        quotemark: [true, 'single', 'jsx-double', 'avoid-escape'],
        'trailing-comma': [false],
    },
    rules: {
        'array-type': [true, 'array'],
        'arrow-parens': false,
        'class-name': true,
        'comment-format': [true, 'check-space'],
        indent: [true, 'tabs'],
        'interface-name': [false],
        'jquery-deferred-must-complete': true,
        'jsdoc-format': true,
        'jsx-alignment': true,
        'jsx-attributes-ordering': true,
        'jsx-boolean-value': true,
        'jsx-curly-spacing': 'never',
        'jsx-no-lambda': true,
        'jsx-no-string-ref': true,
        'jsx-self-close': true,
        'jsx-wrap-multiline': [false],
        'linebreak-style': [true, 'LF'],
        'max-classes-per-file': [1],
        'member-ordering': [false],
        'new-parens': true,
        'no-angle-bracket-type-assertion': true,
        'no-delete-expression': true,
        'no-disable-auto-sanitization': true,
        'no-document-domain': true,
        'no-document-write': true,
        'no-duplicate-parameter-names': true,
        'no-duplicate-switch-case': true,
        'no-empty-interface': false,
        'no-empty-line-after-opening-brace': true,
        'no-exec-script': true,
        'no-function-constructor-with-string-args': true,
        'no-inner-html': true,
        'no-invalid-regexp': true,
        'no-jquery-raw-elements': true,
        'no-octal-literal': true,
        'no-relative-imports': true,
        'no-reserved-keywords': true,
        'no-sparse-arrays': true,
        'no-string-based-set-immediate': true,
        'no-string-based-set-interval': true,
        'no-string-based-set-timeout': true,
        'no-typeof-undefined': true,
        'no-unnecessary-bind': true,
        'no-unnecessary-field-initialization': true,
        'no-unnecessary-local-variable': true,
        'no-unnecessary-override': true,
        'no-unsafe-finally': true,
        'no-var-requires': true,
        'no-with-statement': true,
        'object-literal-key-quotes': [true, 'as-needed'],
        'object-literal-shorthand': false,
        'ordered-imports': [
            true,
            { 'import-sourced-order': 'lowercase-first', 'named-imports-order': 'lowercase-first' },
        ],
        'prefer-array-literal': true,
        'promise-must-complete': true,
        quotemark: [true, 'single', 'jsx-double', 'avoid-escape'],
        'react-aware-member-ordering': [
            true,
            {
                alphabetize: true,
                order: [
                    'private-static-field',
                    'protected-static-field',
                    'public-static-field',
                    'private-static-method',
                    'protected-static-method',
                    'public-static-method',
                    'private-instance-field',
                    'protected-instance-field',
                    'public-instance-field',
                    'constructor',
                    'react-lifecycle-method',
                    'private-instance-method',
                    'protected-instance-method',
                    'public-instance-method',
                    'react-render-method',
                ],
            },
        ],
        'react-hooks-exhaustive-deps': true,
        'react-hooks-nesting': 'error',
        'react-this-binding-issue': true,
        'react-tsx-curly-spacing': [true, 'never'],
        'react-unused-props-and-state': true,
        semicolon: [true, 'always', 'ignore-bound-class-methods'],
        'triple-equals': [true, 'allow-null-check'],
    },
    rulesDirectory: [
        '.',
        // So require.resolve resolves to the main entry, we need the folder.
        // This is a bit hacky and we should probably extend from tslint-microsoft-contrib instead,
        // and then disable the rules we don't want.
        path.dirname(require.resolve('tslint-microsoft-contrib')),
        path.join(path.dirname(require.resolve('tslint-react-hooks')), 'dist'),
    ],
};
